import argparse
import git
import json
import mlflow
from typing import Text


def add_run_tags(
        mlflow_report_path: Text,
        project_url: Text,
        commit_sha: Text,
        commit_tag: Text
) -> None:
    """Adds tags into MLflow run.
    Args:
        mlflow_report_path {Text}: path to mlflow report generated by stage log_metrics
        project_url {Text}: URL of gitlab project
        commit_sha {Text}: commit hash
        commit_tag {Text}: tag name if tag is created
    """

    with open(mlflow_report_path) as mrf:

        report = json.load(mrf)
        tracking_uri = report['tracking_uri']
        exp_id = report['exp_id']
        run_id = report['run_id']

        git_link = f'{project_url}/-/commit/{commit_sha}'
        last_git_tag = '-'

        if len(commit_tag) > 0:
            last_git_tag = f'{project_url}/-/tags/{commit_tag}'

        mlflow.set_tracking_uri(tracking_uri)

        with mlflow.start_run(run_id=run_id, experiment_id=exp_id):
            mlflow.set_tags({
                'git_link': git_link,
                'latest_git_tag': last_git_tag,
                'git_commit': commit_sha
            })


if __name__ == '__main__':

    args_parser = argparse.ArgumentParser()
    args_parser.add_argument('--mlflow-report', dest='mlflow_report')
    args_parser.add_argument('--project-url', dest='project_url')
    args_parser.add_argument('--commit-sha', dest='commit_sha')
    args_parser.add_argument('--commit-tag', dest='commit_tag')
    args = args_parser.parse_args()

    add_run_tags(
        mlflow_report_path=args.mlflow_report,
        project_url=args.project_url,
        commit_sha=args.commit_sha,
        commit_tag=args.commit_tag
    )
